package com.xhkjedu.sexam.task;

import com.xhkjedu.sexam.mapper.exam.ESubjectMapper;
import com.xhkjedu.sexam.mapper.paper.EPaperCorrectTeacherMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @author ywx
 * @classname PaperTask
 * @description 试卷状态定时任务
 * @date 2022/9/13 11:28
 **/
@Slf4j
@Component
public class PaperTask {

    @Resource
    private ESubjectMapper eSubjectMapper;
    @Resource
    private EPaperCorrectTeacherMapper ePaperCorrectTeacherMapper;

    /**
     * 试卷开始考试
     * @Param []
     * @Author ywx
     * @Date 2022/9/13 11:29
     * @return void
     **/
    @Async("threadPoolTaskScheduler")
    @Scheduled(cron = "${cron.updatePaperState}")
    public void startPaper() {
        eSubjectMapper.startPaper();
    }

    /**
     * 试卷结束考试
     * @Param []
     * @Author ywx
     * @Date 2022/9/13 11:30
     * @return void
     **/
    @Async("threadPoolTaskScheduler")
    @Scheduled(cron = "${cron.updatePaperState}")
    public void endPaper() {
        eSubjectMapper.endPaper();
    }

    /*
     * 试题锁定状态超过30分钟后自动取消
     * @Param []
     * @Author ywx
     * @Date 2022/10/23 12:23
     * @return void
     **/
    @Async("threadPoolTaskScheduler")
    @Scheduled(cron = "${cron.updatePaperState}")
    public void unLockQuestion() {
        ePaperCorrectTeacherMapper.unLockQuestion();
    }

}
